Unit AST3C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAFSI_p;

procedure AST3C(var A :Array of Complex; M :Integer; N :Integer;
                var B :Array of Complex; var IERR :Integer);

implementation

procedure AST3C(var A :Array of Complex; M :Integer; N :Integer;
                var B :Array of Complex; var IERR :Integer);
var
K,KB,KF,KP1,NMD2 :Integer;
X :Real;
T,T1 :Complex;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260;
begin
{ *********************************************************C }
{    PEEHE CCTEM A*X=B C OOTEHO OPEEEHHO     C }
{        CMMETPHO TPEXAOHAHO MATPE A.         C }
{ *********************************************************C }

{   YCTAHOBEHE KOHTPO HA BOMOHOCT EPEOHEH }
X  := 0.0;
_10:

{   POBEPKA PABHOCT AAH APAMETPOB M  N }
if ( N  >=  1 ) and (  M  >=  1 ) 
 then goto _20;
IERR  := 65;
UTAFSI('A','S','T','3','C',IERR);
goto _260;
_20:
IERR  := 0;

{   POBEPKA HA CYA 1*1 }
if ( N  >  1 ) 
 then goto _50;
if ( Cabs(A[0+1*M]) <>  0.0 ) 
 then goto _40;
IERR  := -1;
if ( Cabs(B[0]) <>  0.0 ) 
 then goto _30;
B[0] := Cmplx(1.0,0.0);
goto _250;
_30:
IERR  := 67;
UTAFSI('A','S','T','3','C',IERR);
goto _260;
_40:
B[0] := DivC(B[0],A[0+1*M]);
goto _260;

{   PBEEHE MATP K CEAHOMY BY }
_50:
NMD2  := (N - 1) div 2;
if ( N  =  2 ) 
 then goto _90;
KB  := N - 1;
for K:=1 to NMD2 do
 begin
  KF  := K + 1;
  if ( Cabs(A[(K-1)+1*M]) <>  0.0 ) 
   then goto _60;
  IERR  := -K;
  UTAFSI('A','S','T','3','C',IERR);
  goto _260;
_60:
  T  := DivC(A[(KF-1)+0*M],A[(K-1)+1*M]);
  A[(KF-1)+1*M] := SubC(A[(KF-1)+1*M],MulC(T,A[(KF-1)+0*M]));
  B[KF-1] := SubC(B[KF-1],MulC(T,B[K-1]));
  KF  := KB + 1;
  if ( Cabs(A[(KF-1)+1*M]) <>  0.0 ) 
   then goto _70;
  IERR  := -KF;
  UTAFSI('A','S','T','3','C',IERR);
  goto _260;
_70:
  T1  := DivC(A[(KF-1)+0*M],A[(KF-1)+1*M]);
  A[(KB-1)+1*M] := SubC(A[(KB-1)+1*M],MulC(T1,A[(KF-1)+0*M]));
  B[KB-1] := SubC(B[KB-1],MulC(T1,B[KF-1]));
  KB  := KB - 1;
_80:
 end;
_90:
KP1  := NMD2 + 1;
KB  := ((N) Mod (2));
if ( KB  <>  0 ) 
 then goto _110;
if ( Cabs(A[(KP1-1)+1*M]) <>  0.0 ) 
 then goto _100;
IERR  := -KP1;
UTAFSI('A','S','T','3','C',IERR);
goto _260;
_100:
T  := DivC(A[(KP1+0)+0*M],A[(KP1-1)+1*M]);
A[(KP1+0)+1*M] := SubC(A[(KP1+0)+1*M],MulC(T,A[(KP1+0)+0*M]));
B[KP1+0] := SubC(B[KP1+0],MulC(T,B[KP1-1]));
KP1  := KP1 + 1;
_110:

{   PEEHE CCTEM }
if ( Cabs(A[(KP1-1)+1*M]) <>  0.0 ) 
 then goto _130;
IERR  := -KP1;
if ( Cabs(B[KP1-1]) <>  0.0 ) 
 then goto _120;
B[KP1-1] := Cmplx(1.0,0.0);
goto _140;
_120:
IERR  := 67;
UTAFSI('A','S','T','3','C',IERR);
goto _260;
_130:
B[KP1-1] := DivC(B[KP1-1],A[(KP1-1)+1*M]);
_140:
if ( N  =  2 ) 
 then goto _220;
K  := KP1 - 1;
KB  := KP1 + NMD2 - 1;
for KF:=KP1 to KB do
 begin
  T  := SubC(B[K-1],MulC(A[(K+0)+0*M],B[K+0]));
  if ( Cabs(A[(K-1)+1*M]) <>  0.0 ) 
   then goto _160;
  IERR  := -K;
  if ( Cabs(T) <>  0.0 ) 
   then goto _150;
  B[K-1] := Cmplx(1.0,0.0);
  goto _170;
_150:
  IERR  := 67;
  UTAFSI('A','S','T','3','C',IERR);
  goto _260;
_160:
  B[K-1] := DivC(T,A[(K-1)+1*M]);
_170:
  T  := SubC(B[KF+0],MulC(A[(KF+0)+0*M],B[KF-1]));
  if ( Cabs(A[(KF+0)+1*M]) <>  0.0 ) 
   then goto _190;
  IERR  := -KF - 1;
  if ( Cabs(T) <>  0.0 ) 
   then goto _180;
  B[KF+0] := Cmplx(1.0,0.0);
  goto _200;
_180:
  IERR  := 67;
  UTAFSI('A','S','T','3','C',IERR);
  goto _260;
_190:
  B[KF+0] := DivC(T,A[(KF+0)+1*M]);
_200:
  K  := K - 1;
_210:
 end;
_220:
KB  := ((N) Mod (2));
if ( KB  <>  0 ) 
 then goto _250;
T  := SubC(B[0],MulC(A[1+0*M],B[1]));
if ( Cabs(A[0+1*M]) <>  0.0 ) 
 then goto _240;
IERR  := -1;
if ( Cabs(T) <>  0.0 ) 
 then goto _230;
B[0] := Cmplx(1.0,0.0);
goto _250;
_230:
IERR  := 67;
UTAFSI('A','S','T','3','C',IERR);
goto _260;
_240:
B[0] := DivC(T,A[0+1*M]);
_250:
if ( IERR  <>  0 ) 
 then UTAFSI('A','S','T','3','C',IERR);
_260:
end;

end.
